import bee
from bee.segments import *
import libcontext
from libcontext.socketclasses import *
from libcontext.pluginclasses import *
  
import copy
            


class tetris_control(bee.worker):
  b_newscore = buffer('push', 'int')
  
  
  trig_newscore = triggerfunc(b_newscore)
  
  b_reward_block = buffer('pull', 'int')
  
  
  get_reward_block = triggerfunc(b_reward_block)
  
  b_reward_line = buffer('pull', 'int')
  
  
  get_reward_line = triggerfunc(b_reward_line)
  
  b_reward_line2 = buffer('pull', 'int')
  
  
  get_reward_line2 = triggerfunc(b_reward_line2)
  
  b_reward_line3 = buffer('pull', 'int')
  
  
  get_reward_line3 = triggerfunc(b_reward_line3)
  
  b_reward_line4 = buffer('pull', 'int')
  
  
  get_reward_line4 = triggerfunc(b_reward_line4)
  
  b_score = buffer('pull', 'int')
  
  
  get_score = triggerfunc(b_score)
  
  blockgrid = antenna('pull', ('object', 'bgrid'))
  
  drop = antenna('push', 'trigger')
  
  dropped = output('push', 'trigger')
  trig_dropped = triggerfunc(dropped)
  
  
  
  def get_grids(self):
      self.get_grid1()
      self.get_grid2()
                                                                                                    
  
  
  def get_score_and_rewards(self):
    self.get_score()   
    self.get_reward_block()
    self.get_reward_line()
    self.get_reward_line2()
    self.get_reward_line3()
    self.get_reward_line4()
                                                                                                                                                                                                              
  
  grid1 = buffer('pull', ('object', 'bgrid'))
  
  
  get_grid1 = triggerfunc(grid1)
  
  grid2 = buffer('pull', ('object', 'bgrid'))
  
  
  get_grid2 = triggerfunc(grid2)
  
  lost = output('push', 'trigger')
  trig_lost = triggerfunc(lost)
  
  
  @modifier
  def m_drop(self):
    self.get_grids()
    block = copy.copy(self.grid2)
    while block.miny >= 0 and not self.grid1.overlap(block):
      block.translate(0,-1)
    block.translate(0,1)
    self.grid1.merge(block)
    self.get_score_and_rewards()
    linereward = self.remove_lines()
    self.b_newscore = self.b_score + self.b_reward_block + linereward
    self.trig_newscore()
    self.trig_dropped()                                                                                               
  
  @modifier
  def m_move_down(self):
    self.get_grids()
    block = copy.copy(self.grid2)
    block.translate(0,-1)
    if block.miny < 0 or self.grid1.overlap(block):
      self.grid1.merge(self.grid2)
      self.get_score_and_rewards()
      linereward = self.remove_lines()
      self.b_newscore = self.b_score + self.b_reward_block + linereward
      self.trig_newscore()
      self.trig_dropped()
    else:
      self.grid2.translate(0,-1)                                                                                                     
  
  @modifier
  def m_move_left(self):
    self.move_sideways(-1) 
  
  @modifier
  def m_move_right(self):
    self.move_sideways(1)   
  
  @modifier
  def m_place_init(self):
    self.get_grids()
    dx = int(self.grid1.maxx/2)-self.grid2.minx
    self.grid2.maxx += dx
    self.grid2.minx += dx
    dy = self.grid1.maxy - self.grid2.maxy  
    self.grid2.maxy += dy
    self.grid2.miny += dy    
    if self.grid1.overlap(self.grid2): 
       self.trig_lost()                                                                                
  
  @modifier
  def m_rotate_ccw(self):
    self.rotate(1)    
  
  @modifier
  def m_rotate_cw(self):
    self.rotate(3) 
  
  maingrid = antenna('pull', ('object', 'bgrid'))
  
  move_down = antenna('push', 'trigger')
  
  move_left = antenna('push', 'trigger')
  
  move_right = antenna('push', 'trigger')
  
  
  def move_sideways(self, direction):
    self.get_grids()
    block = copy.copy(self.grid2)
    block.translate(direction,0)
    if block.minx < 0: return
    if block.maxx > self.grid1.maxx: return
    if self.grid1.overlap(block): return
    self.grid2.translate(direction,0)                                 
  
  newscore = output('push', 'int')
  
  place_init = antenna('push', 'trigger')
  
  
  def remove_lines(self):
    values = self.grid1.get_values()
    removed = 0
    y = 0
    while y < self.grid1.maxy+1:
      line = [v for v in values if v[1] == y]
      if len(line) == self.grid1.maxx+1:
        values = [v for v in values if v[1] != y]
        values = [(v[0],v[1]-1) if v[1] > y else v for v in values]
        removed += 1
      else:
        y += 1
    if removed: 
      self.grid1.set_values(values)
      if removed == 1: return self.b_reward_line
      if removed == 2: return self.b_reward_line2
      if removed == 3: return self.b_reward_line3
      if removed == 4: return self.b_reward_line4
    return 0                                                                                      
  
  reward_block = antenna('pull', 'int')
  
  reward_line = antenna('pull', 'int')
  
  reward_line2 = antenna('pull', 'int')
  
  reward_line3 = antenna('pull', 'int')
  
  reward_line4 = antenna('pull', 'int')
  
  
  def rotate(self, times):
    self.get_grids()
    block = copy.copy(self.grid2)
    block.rotate(times)
    if block.minx < 0: 
      block.translate(-block.minx,0)
    if block.maxx > self.grid1.maxx: 
      block.translate(self.grid1.maxx-block.maxx,0)
    if self.grid1.overlap(block): return
    self.grid2.set(block)                                         
  
  rotate_ccw = antenna('push', 'trigger')
  
  rotate_cw = antenna('push', 'trigger')
  
  score = antenna('pull', 'int')
  
  connect(maingrid, grid1)
  connect(blockgrid, grid2)
  trigger(place_init, m_place_init)
  trigger(move_down, m_move_down)
  trigger(move_left, m_move_left)
  trigger(move_right, m_move_right)
  trigger(drop, m_drop)
  connect(score, b_score)
  connect(b_newscore, newscore)
  trigger(rotate_cw, m_rotate_cw)
  trigger(rotate_ccw, m_rotate_ccw)
  connect(reward_block, b_reward_block)
  connect(reward_line, b_reward_line)
  connect(reward_line2, b_reward_line2)
  connect(reward_line3, b_reward_line3)
  connect(reward_line4, b_reward_line4)
   
