from .bglnode import bglnode

import functools

has_bgl = False
try:
  from bgl import *
  has_bgl = True
except ImportError:
  pass

class general(): pass
first = True
def draw_image(tex_id, color, texco, transparency):
  glEnable(GL_TEXTURE_2D)

  if transparency:
    glEnable(GL_BLEND)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)

  glBindTexture(GL_TEXTURE_2D, tex_id)
  glColor4f(*color)

  glBegin(GL_QUADS)
  positions = [(0,0), (1,0), (1,-1), (0,-1)]
  for tex, pos in zip(texco, positions):
    glTexCoord2f(tex[0], tex[1])
    glVertex2f(pos[0], pos[1])
  glEnd()

  glBindTexture(GL_TEXTURE_2D, 0)

  if transparency:
    glDisable(GL_BLEND)

  glDisable(GL_TEXTURE_2D)
  
class blenderimage(object):
  def __init__(self, identifier, imagefile, parameters, textureloader):
    self.identifier = identifier
    self.imagefile = imagefile
    self.parameters = parameters
    self.textureloader = textureloader

    id_buf = Buffer(GL_INT, 1)
    #KLUDGE: glGenTextures does not work on Windows before BGE has been fired up
    #glGenTextures(1, id_buf)
    #self.tex_id = id_buf.to_list()[0] if hasattr(id_buf, "to_list") else id_buf.list[0]
    import random
    self.tex_id = random.randint(1, 99999)
    self.update_image()

  def update(self,parentnode):
    self.node.removeNode()
    self.update_image()  
    self.node.reparentTo(parentnode)
        
  def update_image(self):  
    import bge
    
    texco0=[(0,0), (1,0), (1,1), (0,1)]
    texco = getattr(self.parameters, "texco", texco0)    
    transparency = getattr(self.parameters, "transparency", False)    
    color = getattr(self.parameters, "color", (1,1,1,1))    

    image = bge.texture.ImageFFmpeg(self.imagefile.value)
    image.scale = False
    if image.image is None: raise ValueError(self.imagefile.value)
    self.image = image
    
    self.textureloader(self.tex_id, self.image.image, self.image.size)
    func = functools.partial(draw_image, self.tex_id, color, texco, transparency)
    drawfunc = general()
    drawfunc.draw = func
    node = bglnode()
    node.children = [drawfunc]
    self.node = node
    return node
  
  def __del__(self):
    id_buf = Buffer(GL_INT, 1)
    id_buf[0] = self.tex_id
    glDeleteTextures(1, id_buf)

