class box2d(object):
  def __init__(self, x, y,sizex,sizey,mode="pixels"):
    self.x = x
    self.y = y
    if sizex <= 0: raise ValueError(sizex)
    if sizey <= 0: raise ValueError(sizey)
    self.sizex = sizex
    self.sizey = sizey
    assert mode in ("pixels","standard","aspect")
    self.mode = mode
  def to_std(self, canvasx, canvasy):
    if self.mode == "standard": return self
    elif self.mode == "pixels": 
      xx, yy = pixels_to_std(self.x,self.y, canvasx, canvasy)
      mx, my = pixels_to_std(self.x+self.sizex,self.y+self.sizey, canvasx, canvasy)
      sizexx,sizeyy = mx-xx,my-yy
      ret = box2d(xx,yy,sizexx,sizeyy,"standard")
      return ret
    elif self.mode == "aspect": 
      xx, yy = aspect_to_std(self.x,self.y, canvasx, canvasy)
      mx, my = aspect_to_std(self.x+self.sizex,self.y+self.sizey, canvasx, canvasy)
      sizexx,sizeyy = mx-xx,my-yy
      ret = box2d(xx,yy,sizexx,sizeyy,"standard")
      return ret
    raise ValueError(self.mode)
              
def std_to_pixels(x,y,canvasx,canvasy):
  return x*canvasx,y*canvasy

def aspect_to_pixels(x,y,canvasx,canvasy):
  return x*canvasy,y*canvasy

def pixels_to_std(x,y,canvasx,canvasy):
  return float(x)/canvasx, float(y)/canvasy

def aspect_to_std(x,y,canvasx,canvasy):
  return float(x)*canvasy/canvasx, y
